{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainUnit;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls, mckObjs {$ENDIF};
{$ELSE}
{$I uses.inc} mirror,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    MainMenu1: TKOLMainMenu;
    ListBox1: TKOLListBox;
    KOLApplet1: TKOLApplet;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    GroupBox1: TKOLGroupBox;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    Label4: TKOLLabel;
    Label3: TKOLLabel;
    Label5: TKOLLabel;
    Label6: TKOLLabel;
    OpenDirDialog1: TKOLOpenDirDialog;
    GroupBox2: TKOLGroupBox;
    Label7: TKOLLabel;
    Label8: TKOLLabel;
    Label9: TKOLLabel;
    Label10: TKOLLabel;
    Button2: TKOLButton;
    Label11: TKOLLabel;
    Label12: TKOLLabel;
    Button3: TKOLButton;
    Label13: TKOLLabel;
    EditBox1: TKOLEditBox;
    Button4: TKOLButton;
    ProgressBar1: TKOLProgressBar;
    procedure KOLForm1N4Menu(Sender: PMenu; Item: Integer);
    procedure KOLForm1N2Menu(Sender: PMenu; Item: Integer);
    procedure Button2Click(Sender: PObj);
    procedure KOLForm1Show(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure ListBox1SelChange(Sender: PObj);
    procedure Button4Click(Sender: PObj);
    procedure KOLForm1N5Menu(Sender: PMenu; Item: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  procedure UpdateTotalInfo;
  procedure UpdateSelectionInfo;
  function UpCaseStr(s: string): string;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  TotalFiles: LongInt;
  DataOffset: LongInt;
  FileSize: LongInt;
  OutputDirectory: string;
  CurDir: string;
  Entries: array of record
                      Junk_1: array[1..4]of char;
                      NameChar: array[0..63]of char;
                      NameString: string;
                      Offset: LongInt;
                      Size: LongInt;
                      Junk_2: array[1..4]of char;
                      Compressed: Boolean;
                      Selected: Boolean;
                    end;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses About;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainUnit_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1N4Menu(Sender: PMenu; Item: Integer);
begin
  Form.Close;
end;

procedure TForm1.KOLForm1N2Menu(Sender: PMenu; Item: Integer);
var
  F: PStream;
  TempGSCid: array[1..6]of char;
  i,j: LongInt;
  Percent: LongInt;
begin
  if not OpenSaveDialog1.Execute then Exit;
  F:=NewReadFileStream(OpenSaveDialog1.FileName);
  F.Read(TempGSCid,6);
  if not (TempGSCid='GSCfmt') then
  begin
    ShowMessage('  !');
    F.Free;
    Exit;
  end;
  FileSize:=F.Size;
  F.Seek($0A,spBegin);
  F.Read(TotalFiles,4);
  SetLength(Entries,TotalFiles);
  F.Seek($0E,spBegin);
  for i:=1 to TotalFiles do
  begin
    F.Read(Entries[i-1].Junk_1,4);
    F.Read(Entries[i-1].NameChar,64);
    for j:=0 to 63 do
      if (Entries[i-1].NameChar[j]='/')or(Entries[i-1].NameChar[j]='\')then Entries[i-1].NameChar[j]:='_';
    Entries[i-1].NameString:=Copy(Entries[i-1].NameChar,1,64);
    F.Read(Entries[i-1].Offset,4);
    Entries[i-1].Offset:=Entries[i-1].Offset xor $FFFFFFFF;
    F.Read(Entries[i-1].Size,4);
    F.Read(Entries[i-1].Junk_2,4);
    F.Read(Entries[i-1].Compressed,1);
    ListBox1.Add(Entries[i-1].NameString);
    if Round(100*(i/TotalFiles))<>Round(ProgressBar1.Progress) then
    begin
      ProgressBar1.Progress:=Round(100*(i/TotalFiles));
//      ProgressBar1.Update;
    end;
  end;
  DataOffset:=F.Position;
  F.Free;
  UpdateTotalInfo;
end;

procedure UpdateTotalInfo;
begin
  Form1.Label3.Caption:=Form1.OpenSaveDialog1.FileName;
  Form1.Label4.Caption:=Int2Str(TotalFiles);
  Form1.Label6.Caption:=Int2Str(FileSize);
end;

procedure UpdateSelectionInfo;
var
  i,TS: LongInt;
begin
  TS:=0;
  for i:=1 to Form1.ListBox1.Count do
  if Form1.ListBox1.ItemSelected[i-1] then
  begin
    TS:=TS+Entries[i-1].Size;
    Entries[i-1].Selected:=True;
  end else Entries[i-1].Selected:=False;
  Form1.Label9.Caption:=Int2Str(Form1.ListBox1.SelLength);
  Form1.Label10.Caption:=Int2Str(TS);
end;
procedure TForm1.Button2Click(Sender: PObj);
const
  BlockSize=10000;
var
  i,j,z: LongInt;
  FGSC,F: PStream;
  b1,b2,XORKey: Byte;
  TotalBlocks: LongInt;
  Buffer: array[0..BlockSize-1]of byte;
begin
  if ListBox1.SelLength=0 then Exit;
  // 
  FGSC:=NewReadFileStream(OpenSaveDialog1.FileName);
  XORKey:=$78;
//  Update;
  // 
  for i:=1 to TotalFiles do
  begin
    if ListBox1.ItemSelected[i-1] then
    begin
      FGSC.Seek(DataOffset+Entries[i-1].Offset,spBegin);
      F:=NewWriteFileStream(OutputDirectory+'\'+Entries[i-1].NameString);
      {***   }
      if Entries[i-1].Compressed then
      begin
        TotalBlocks:=Entries[i-1].Size div BlockSize;
        if TotalBlocks=0 then
        begin
          FGSC.Read(Buffer,Entries[i-1].Size);
          for j:=1 to Entries[i-1].Size do Buffer[j-1]:=Buffer[j-1] xor XORKey;
          F.Write(Buffer,Entries[i-1].Size);
        end else
        begin
          for z:=1 to TotalBlocks do
          begin
            FGSC.Read(Buffer,BlockSize);
            for j:=1 to BlockSize do Buffer[j-1]:=Buffer[j-1] xor XORKey;
            F.Write(Buffer,BlockSize);
          end;
          if Entries[i-1].Size-TotalBlocks*BlockSize>0 then
          begin
            FGSC.Read(Buffer,Entries[i-1].Size-TotalBlocks*BlockSize);
            for j:=1 to Entries[i-1].Size-TotalBlocks*BlockSize do Buffer[j-1]:=Buffer[j-1] xor XORKey;
            F.Write(Buffer,Entries[i-1].Size-TotalBlocks*BlockSize);
          end;
        end;
      end else Stream2Stream(F,FGSC,Entries[i-1].Size);
      {***   }
      F.Free;
    end;
    if Round(100*(i/TotalFiles))<>Round(ProgressBar1.Progress) then
    if Frac(i/10)=0.0 then
    begin
      ProgressBar1.Progress:=Round(100*(i/TotalFiles));
//      ProgressBar1.Update;
    end;
  end;
  //
  FGSC.Free;
end;

procedure TForm1.KOLForm1Show(Sender: PObj);
begin
  GetDir(0,CurDir);
  OutputDirectory:=CurDir;
  Label12.Caption:=Copy(OutputDirectory,1,3)+' ...\'+ExtractFileName(OutputDirectory);
end;

procedure TForm1.Button3Click(Sender: PObj);
begin
  OpenDirDialog1.InitialPath:=OutputDirectory;
  if OpenDirDialog1.Execute then OutputDirectory:=OpenDirDialog1.Path;
  Label12.Caption:=Copy(OutputDirectory,1,3)+' ...\'+ExtractFileName(OutputDirectory);
end;

procedure TForm1.ListBox1SelChange(Sender: PObj);
begin
  UpdateSelectionInfo;
end;

{    }
function UpCaseStr(s: string): string;
var
  i: Byte;
  t: string;
begin
  t:='';
  if Length(s)>0 then for i:=1 to Length(s) do t:=t+UpCase(s[i]);
  UpCaseStr:=t;
end;

procedure TForm1.Button4Click(Sender: PObj);
var
  z1,z2: string;
  i: LongInt;
begin
  if (ListBox1.Count=0) then Exit;
  z1:=UpCaseStr(EditBox1.Text);
  if Length(z1)=0 then Exit;
  for i:=1 to TotalFiles do
  if Pos(z1,UpCaseStr(ListBox1.Items[i-1]))>0 then ListBox1.ItemSelected[i-1]:=True else if ListBox1.ItemSelected[i-1]=True then ListBox1.ItemSelected[i-1]:=False;
  UpdateSelectionInfo;
end;

procedure TForm1.KOLForm1N5Menu(Sender: PMenu; Item: Integer);
begin
  Form2.Form.ShowModal;
end;

end.








